module java.util.TreeMap;

import java.lang.all;
import java.util.Map;
import java.util.Set;
import java.util.Collection;
import java.util.SortedMap;
import java.util.TreeSet;
import java.util.ArrayList;

static import tango.util.container.SortedMap;

class TreeMap : Map, SortedMap {
    alias tango.util.container.SortedMap.SortedMap!(Object,Object) MapType;
    private MapType map;

    public this(){
        map = new MapType();
    }
    public this(Comparator c){
        implMissing( __FILE__, __LINE__ );
    }
    public this(Map m){
        implMissing( __FILE__, __LINE__ );
    }
    public this(SortedMap m){
        implMissing( __FILE__, __LINE__ );
    }
    public void clear(){
        map.clear();
    }
    Comparator     comparator(){
        implMissing( __FILE__, __LINE__ );
        return null;
    }
    public bool containsKey(Object key){
        Object v;
        return map.get(key, v );
    }
    public bool containsKey(String key){
        return containsKey(stringcast(key));
    }
    public bool containsValue(Object value){
        return map.contains(value);
    }
    public Set  entrySet(){
        TreeSet res = new TreeSet();
        foreach( k, v; map ){
            res.add( new MapEntry(this,k) );
        }
        return res;
    }
    public override int opEquals(Object o){
        if( auto other = cast(TreeMap) o ){
            if( other.size() !is size() ){
                return false;
            }
            foreach( k, v; map ){
                Object vo = other.get(k);
                if( v != vo ){
                    return false;
                }
            }
            return true;
        }
        return false;
    }
    Object         firstKey(){
        foreach( k; map ){
            return k;
        }
        throw new tango.core.Exception.NoSuchElementException( "TreeMap.firstKey" );
    }
    public Object get(Object key){
        implMissing( __FILE__, __LINE__ );
        return null;
    }
    public Object get(String key){
        return get(stringcast(key));
    }
    public override hash_t toHash(){
        // http://java.sun.com/j2se/1.4.2/docs/api/java/util/AbstractMap.html#hashCode()
        hash_t res = 0;
        foreach( e; entrySet() ){
            res += e.toHash();
        }
        return res;
    }
    SortedMap headMap(Object toKey){
        implMissing( __FILE__, __LINE__ );
        return null;
    }
    public bool isEmpty(){
        return map.isEmpty();
    }
    public Set keySet(){
        TreeSet res = new TreeSet();
        foreach( k; map ){
            res.add( k );
        }
        return res;
    }
    Object lastKey(){
        Object res;
        foreach( k; map ){
            res = k;
        }
        if( map.size() ) return res;
        throw new tango.core.Exception.NoSuchElementException( "TreeMap.lastKey" );
    }
    public Object put(Object key, Object value){
        if( map.contains(key) ){ // TODO if tango has opIn_r, then use the "in" operator
            Object res = map[key];
            map[key] = value;
            return res;
        }
        map[key] = value;
        return null;
    }
    public Object put(String key, Object value){
        return put(stringcast(key), value);
    }
    public Object put(Object key, String value){
        return put(key, stringcast(value));
    }
    public Object put(String key, String value){
        return put(stringcast(key), stringcast(value));
    }
    public void   putAll(Map t){
        foreach( k, v; t ){
            put( k, v );
        }
    }
    public Object remove(Object key){
        Object res;
        map.take(key,res);
        return res;
    }
    public Object remove(String key){
        return remove(stringcast(key));
    }
    public int    size(){
        return map.size();
    }
    SortedMap      subMap(Object fromKey, Object toKey){
        implMissing( __FILE__, __LINE__ );
        return null;
    }
    SortedMap      tailMap(Object fromKey){
        implMissing( __FILE__, __LINE__ );
        return null;
    }
    public Collection values(){
        ArrayList res = new ArrayList( size() );
        foreach( k, v; map ){
            res.add( v );
        }
        return res;
    }

    public int opApply (int delegate(ref Object value) dg){
        return map.opApply( dg );
    }
    public int opApply (int delegate(ref Object key, ref Object value) dg){
        return map.opApply( dg );
    }
}

